{*****************************************************************************}
{*									     *}
{*				   Snake Byte				     *}
{*				  version 1.13				     *}
{*			     by George Petrov /YGP/			     *}
{*		 (c) 1989, 1990 Software R&D Laboratory, Sofia		     *}
{*									     *}
{*****************************************************************************}
{*									     *}
{*		      㢠  ࠢ  ᫥ 稭:		     *}
{*  -  类      N 窨,  N   ६;  *}
{*  -  类 ६     窨;			     *}
{*  -   ६     㡨        *}
{*    ⮫ 窨     ; 			     *}
{*									     *}
{*****************************************************************************}
{$define forpeter}


program TheSnake(message);
  (*) {*) uses DOS, crt, UniPascal; {*}

  const HghScrName = 'TheSnake.HGH';                 {   䠩  窨 }
	LevelsName = 'TheSnake.Lvl';                  {   䠩   }

	Xsize = 40;	       {   ᪠  X (⥫ ࠬ) }
	Ysize = 24;	       {   ᪠  Y (⥫ ࠬ) }


	EntryX = Xsize div 2;
	EntryY = Ysize -1;
	ExitX  = Xsize div 2;
	ExitY  = 0;

        {$ifdef ForPeter}
        Ndelays = 400;
        {$else}
	Ndelays = (*) 25 {*) 100 {*};	    { ६ﭥ  ᥪ 室 (ms) }
        {$endif}

	MaxTime = Ndelays * 4 * 20;	    { ६  捻    }
						     {      4 }
	Tslice = MaxTime div (Ysize -2);

	HeartsPerLevel = 10;
	IncHearts      = 3;

	MaxSnakeSize = Xsize * Ysize - 2*Xsize - 2*Ysize + 4;
	StartSize= 5;		  {   ꫦ 碠 ⭠ 窠 }
	IncSize = 7;	{    㢥砢 ꫦ ᫥ 类 堯 }

	FullCh	   (*){*): string[2] {*} = '';
	ClockCh    (*){*): string[2] {*} = '';
	HeartCh    (*) = #27#3{*): string[2] = #3 {*};
	EmptyCh    (*){*): string[2] {*} = ' ';
	BrdrClr    = (*)$70{*) 7{*};		     { White Border (default) }
	HeartClr   = (*)$40{*) 4{*};				  { Red Heart }
	SnakeColor = (*)$20{*) 2{*};				{ Green snake }
	NormalText = (*)$70{*) 7{*};				 { White text }

	LeftKey  = (*)#$c1{*)#75{*};
	RightKey = (*)#$c2{*)#77{*};
	DownKey  = (*)#$c3{*)#80{*};
	UpKey	 = (*)#$c4{*)#72{*};
	ESCkey	 = #27;

  type HighScore = record
	 Name:	  string[13]; Rnd1: Cardinal;		{ 砩 ᫠  }
	 Score:   LongInt;    Rnd2: Cardinal;		{  㤠  ࠣ }
	 Level:   Natural;    Rnd3: Cardinal;
	 Date:	  Cardinal;   Rnd4: Cardinal;
	 Time:	  Cardinal;   Rnd5: Cardinal;
	 CheckSum: Cardinal;  Rnd6: Cardinal;
       end; { HighScore }

       Levels = packed array [0..Xsize-1, 0..Ysize-1] of byte;

       ba = packed array [0..100] of byte;

  var LevelNo: natural; 				   { current Level No }
      Nhearts,				    {    ⠢   }
      Nsnakes: natural; 			       {     }
      Score:   LongInt; 		      {  窨 祭   }

      Time: integer;
      NextTimeSlice: natural;
      Snake: record
	Size: Natural;
	HeadCh: string[2];
	Ch: (*) char {*) string[2] {*};
	Vx, Vy: integer;					   { -1, 0, 1 }
	HeadX, HeadY: ShortCard;
	X, Y: packed array [0..MaxSnakeSize-1] of ShortCard;
      end; { Snake }

      Gate: record	{  १     ᬥ  窮 }
	X, Y: integer;
      end; { Gate }

      Crash: boolean;
      NoErrors: boolean;		   {   ࠢ   誠 }
      HrtOnScr: natural;

      HeadsCh: array [-1..1, -1..1] of string[2];
      DirCh: packed array [-1..(*)2{*)1{*}, -1..(*)2{*)1{*}] of
	(*) char {*) string[2] {*};

      SaveBrdr: shortcard;	    {  梥  ࠤ   }
      Board: Levels;					    { ࠫ ᪠ }
      PlayerName: string[13];				      { Player's name }

      HasntHigh: boolean;
      Position: integer;
      HS: array [1..16] of HighScore;

  (*) {$I ..\InLines } (*)

{$ifNdef UniPas}

  var SaveCH: byte;
      not_40: boolean;
      SaveMode: byte;
      p50: dirStr;
      n50: NameStr;
      e50: ExtStr;

  procedure GotoXY(X, Y: byte);
  begin
  if not_40 then x:= x + x - 1;
  crt.GotoXY(x, y);
  end; { GotoXY }

  procedure Cursor(visible: boolean);
    var r: registers;
  begin
  r.AH:= $03; r.BH:= 0; { Get cursor size }
  intr($10, r);
  r.AH:= 01; { Set CursorSize }
  if visible
    then r.CH:= SaveCH
    else begin SaveCh:= r.ch; r.CH:= $20; end;
  intr($10, r);
  end; { Cursor }

  procedure TextCo40;
    var r: registers;
  begin
  r.AH:= $0f; intr($10, r); SaveMode:= r.AL;
  case r.AL of
    0, 1: { OK };
    2, 3: r.AL:= r.AL -2;   { make 0/1 }
    4, 5: r.AL:= 5 - r.AL; { --- " --- }
    7: ;
    else r.AL:= 1;
    end; { case }

  TextMode(r.AL);
  r.AH:= $0f; intr($10, r);
  not_40:= r.AH <> 40;
  end; { TextCo40 }

  procedure ReturnMode;
    var r: registers;
  begin
  r.AH:= 0; r.AL:= SaveMode;
  intr($10, r);
  r.AH:= $0f; intr($10, r);
  not_40:= r.AH <> 40;
  end; { ReturnMode }

  procedure TextColor(clr: byte);
  begin
  if SaveMode <> 7 { not Monochrome }
    then crt.TextColor(clr);
  end; { TextColor }

{$endif}

  procedure ShowTop;
    var i, j: integer;
	cs: cardinal;
	bap: ^ba;

    procedure WriteDateTime;
      var day, month, year: natural;
	  w, hour, min: natural;
    begin
    hour:= HS[i].Time div 60;
    min:= HS[i].Time mod 60;
    w:= HS[i].date;
    day:=   w mod 32; w:= w div 32;
    month:= w mod 16; w:= w div 16;
    year:=  w + 80;

    if day <> 0
      then begin write(hour: 3, ':');
	   if min < 10 then write('0');
	   write(min);
	   write(day:3, '.');
	   if month < 10 then write('0');
	   write(month, '.');
	   write(year);
	   end
      else write('': 3 + 1 + 2 + 3 + 1 + 2 + 1 + 2);
    end; { WriteDateTime }

    label Again;
    var f: file;
	wrks: string;

  begin { ShowTop }
  writeln('  - ⨦': 37);
  writeln('No            窨     ');
	  { 1. ............ ..... 33 14:32 11.12.89}
  for i:= 1 to 16 do
    begin write(i: 2, '. ');
Again:
    if HS[i].level <> 0
      then begin
	   cs:= 0; bap:= addr(HS[i]);
	   for j:= 0 to SizeOf(HS[i])-1 do
	     inc(cs, bap^[j]);
	   dec(cs, cardinal(Hi(HS[i].CheckSum)) +cardinal(Lo(HS[i].CheckSum)));

	   if cs <> HS[i].CheckSum
	     then begin (*) MoveWords(HS[i+1],HS[i],WordSizeOf(HS[1])*(16-i));
		  {*) Move(HS[i+1], HS[i], SizeOf(HS[i])*(16-i)); {*}

		  (*) FillWord(HS[16], WordSizeOf(HS[16]), 0);
		  {*) FillChar(HS[16], SizeOf(HS[16]), #0); {*}

		  (*) rewrite(f, HghScrName);
		  {*) Fsplit(SYSTEM.ParamStr(0), p50, n50, e50);
		      (*$ifdef IN_IDE*) p50:= ''; (*$endif*)
		      assign(f, p50+HghScrName); rewrite(f, 1); {*}

		  BlockWrite(f, HS, SizeOf(HS));
		  close(f);
		  goto Again;
		  end
	     else begin
		  if HS[i].Score < 100000
		    then begin
			 write(HS[i].name (*): -13{*),
			       '': 13 - length(HS[i].name){*});
			 write(HS[i].Score: 5, HS[i].Level: 3);
			 end
		    else begin wrks:= HS[i].name;
			 if 10 < length(wrks) then wrks[0]:= #10;
			 write(wrks(*): -10{*),'': 10 - length(wrks){*});
			 write(HS[i].Score: 8, HS[i].Level: 3);
			 end;
		  WriteDateTime;
		  end;
	   end(*); {*) else if not not_40 then writeln; {*}
    (*){*)if not_40 then {*} writeln;
    end;
  end; { ShowTop }

  procedure ReadHighScores;
    var i: integer;
	f: file of HighScore;
  begin
  (*) reset(f, HghScrName);
  {*) Fsplit(SYSTEM.ParamStr(0), p50, n50, e50);
      (*$ifdef IN_IDE*) p50:= ''; (*$endif*)
      assign(f, p50+HghScrName); reset(f); {*}
  if HasntHigh
    then (*) FillWord(HS, WordSizeOf(hs), 0);
	 {*) FillChar(HS, SizeOf(hs), 0); {*}

  i:= 1;
  while (IOresult = 0) and (i <= 16) do
    begin read(f, HS[i]); inc(i); end;

  HasntHigh:= false;
  (*){*) Close(f); if IOresult <> 0 then; {*}
  end; { ReadHighScores }

  procedure DoubleLine;
    var i: integer;
  begin
  for i:= 1 to 40 do write('');
  (*){*) if not_40 then {*} writeln;
  end; { DoubleLine }

  procedure Title;
  begin
  ClrScr;						       { Clear Screen }
  writeln('': 23);
  writeln('(c) 1989,90  "ணࠬ ᨣ"');
  writeln(' 1.13': 25);
  DoubleLine;
  end; { Title }

  procedure ReadLevel(var No: natural);
    var x: integer;
	f: file;
  begin
  (*) reset(f, LevelsName);
  {*) Fsplit(SYSTEM.ParamStr(0), p50, n50, e50);
      (*$ifdef IN_IDE*) p50:= ''; (*$endif*)
      assign(f, p50+LevelsName); reset(f, 1); {*}
  Seek(f, No * SizeOf(Board));
  if IOresult = 0
    then begin BlockRead(f, Board, SizeOf(Board));
	 Inc(No, ord(IOresult = 0));
	 end
    else begin FillChar(Board, SizeOf(Board), #0);
	 FillChar(Board[0], SizeOf(Board[0]), chr(BrdrClr));
	 FillChar(Board[Xsize-1], SizeOf(Board[0]), chr(BrdrClr));
	 for x:= 1 to Xsize -2 do
	   begin Board[x, 0]:= BrdrClr; Board[x, Ysize-1]:= BrdrClr; end;
	 end;
  (*){*) Close(f); if IOresult <> 0 then; {*}
  end; { ReadLevel }

  procedure GetName;
  begin
  (*){*)Cursor(true);{*}
  write(', ꢥ  : ');
  readln(PlayerName);
  (*){*)Cursor(false);{*}
  end; { GetName }

  procedure WriteStatus;
    {$ifNdef UniPas}
    procedure gotoxy(x, y: byte);
    begin
    crt.GOTOXY(x, y);
    end;
    {$endif}
  begin
  TextColor(NormalText);
  GotoXY( 3, 25); write(Nhearts: 2);
  GotoXY(12, 25); write(Nsnakes: 2);
  GotoXY(21, 25); write(LevelNo: 3);
  GotoXY(32, 25); write(Score: 8);
  TextColor(SnakeColor);
  end; { WriteStatus }

  procedure DrawBoard;
    var x, y: integer;
	cell: byte;
  begin
  GotoXY(1, 1);
  for y:= 0 to Ysize-1 do
    begin
    for x:= 0 to Xsize-1 do
      begin cell:= Board[x, y];
      TextColor(cell);
      if Cell <> 0
	then write(FullCh)
	else write(EmptyCh);
      end; { for x }
    (*)writeln;{*) GotoXY(1, y+2); {*}
    end; { for y }
  TextColor(SnakeColor);
  end; { DrawBoard }

  procedure PutHeart(forced: boolean);
    var RndX, RndY: integer;
  begin
  if (HrtOnScr = 0) or forced
    then begin
	 repeat RndX:= Random(Xsize - 2) + 1; RndY:= Random(Ysize - 2) + 1;
	 until (Board[RndX, RndY] = 0) and
	       ((Snake.HeadX <> RndX) or (Snake.HeadY <> RndY));
	 Board[RndX, RndY]:= $ff;
	 Inc(HrtOnScr);
	 GotoXY(RndX+1, RndY+1); TextColor(HeartClr); write(HeartCh);
	 end;
  for RndY:= Ysize - Time div Tslice -1 downto 1 do
    begin GotoXY(1, RndY); TextColor(Board[0, RndY-1]);       write(FullCh);
    GotoXY(Xsize, RndY);   TextColor(Board[Xsize-1, RndY-1]); write(FullCh);
    end;
  Time:= MaxTime;
  NextTimeSlice:= Time - Time mod Tslice;
  TextColor(SnakeColor);
  end; { PutHeart }

  procedure MakeSnake;
  begin
  Crash:= false;
  FillChar(Snake.X, SizeOf(Snake.X), #0);
  FillChar(Snake.Y, SizeOf(Snake.Y), #0);

  if Snake.Size = 0 then Snake.Size:= StartSize;

  Snake.Vx:= 0; Snake.Vy:= -1;
  Snake.HeadX:= EntryX;
  Snake.HeadY:= EntryY;
  Snake.Ch:= DirCh[0, -1];
  SaveBrdr:= Board[EntryX, EntryY];
  Snake.HeadCh:= HeadsCh[0, -1];
  TextColor(SnakeColor);
  GotoXY(Snake.HeadX+1, Snake.HeadY+1); write(Snake.HeadCh);
  end; { MakeSnake }

  procedure MoveSnake;
    var NewX, NewY,
	LastX, LastY: shortcard;
	MakeNewHeart: boolean;
  begin
  NewX:= Snake.HeadX + Snake.Vx;
  NewY:= Snake.HeadY + Snake.Vy;
  MakeNewHeart:= false;
  if Board[NewX, NewY] = $ff
    then begin MakeNewHeart:= true; { 堯嬥   }
	 Board[NewX, NewY]:= 0;
	 {   ᪠ }
	 dec(Nhearts); dec(HrtOnScr);
	 inc(Score, round(LongInt(LevelNo) * Time / MaxTime));
	 Inc(Snake.Size, IncSize);
	 WriteStatus;
	 end;

  GotoXY(Snake.HeadX+1, Snake.HeadY+1);
  write(Snake.Ch);
  Board[Snake.HeadX, Snake.HeadY]:= $fe; { Snake body }
  LastX:= Snake.X[Snake.Size]; LastY:= Snake.Y[Snake.Size];
  if LastX <> 0
    then begin GotoXY(LastX+1, LastY+1);
	 if LastY = EntryY
	   then begin TextColor(SaveBrdr);
		write(FullCh);
		TextColor(SnakeColor);
		Board[EntryX, EntryY]:= SaveBrdr;
		end
	   else begin write(EmptyCh);
		Board[LastX, LastY]:= 0;
		end;
	 end;
  Move(Snake.X[0], Snake.X[1], Snake.Size);
  Move(Snake.Y[0], Snake.Y[1], Snake.Size);
  Snake.X[0]:= Snake.HeadX; Snake.Y[0]:= Snake.HeadY;

  Snake.HeadX:= NewX; Snake.HeadY:= NewY;
  GotoXY(Snake.HeadX+1, Snake.HeadY+1); write(Snake.HeadCh);
  Snake.Ch:= DirCh[Snake.Vx, Snake.Vy];
  Crash:= Board[Snake.HeadX, Snake.HeadY] <> 0;
  if MakeNewHeart and not Crash then
    if 0 < Nhearts
      then PutHeart(false)
      else begin Gate.X:= ExitX; Gate.Y:= ExitY;
	   GotoXY(Gate.X+1, Gate.Y+1); write(EmptyCh);
	   end;
  end; { MoveSnake }

  procedure TestKeyBoard;
    var Wait: natural;
	NewVx, NewVy: integer;
	(*)ch: char;(*)
  begin
  Wait:= 0;
  while not KeyPressed and (Wait < Ndelays) do
    begin delay(1); Inc(Wait); dec(Time);
    if (Time < NextTimeSlice) and (0 < Time) and (Nhearts <> 0)
      then begin NextTimeSlice:= Time - Time mod Tslice;
	   NewVy:= Ysize - Time div Tslice - 1;
	   TextColor(Board[0, NewVy-1]);
	   GotoXY(1, NewVy);
	   write(ClockCh);
	   TextColor(Board[Xsize-1, NewVy-1]);
	   GotoXY(Xsize, NewVy);
	   write(ClockCh);
	   TextColor(SnakeColor);
	   end;
    end; { while }

  if (Time < 0) and (Nhearts <> 0)
    then begin inc(Nhearts, IncHearts);
	 for wait:= 1 to IncHearts do PutHeart(true);
	 WriteStatus;
	 end;

  if KeyPressed
    then begin
	 (*)ch:= ReadKey;
	 if ch in [LeftKey, RightKey, UpKey, DownKey, ESCkey]
	   then begin
	 {*) case ReadKey of
	   ESCkey: begin crash:= true; (* give up *)
		   score:= 0; Nsnakes:= 1;
		   end;
	   #0: {*} begin NewVx:= Snake.Vx; NewVy:= Snake.Vy;
	       case (*)ch{*)ReadKey {*}of
		 (*)
		 ESCkey:   begin crash:= true; { give up }
			   score:= 0; Nsnakes:= 1;
			   end;
		 (*)
		 LeftKey:  begin NewVy:= 0;
			   if Snake.Vx = 0 then NewVx:= -1;
			   Snake.Vx:= NewVx;
			   end;
		 RightKey: begin NewVy:= 0;
			   if Snake.Vx = 0 then NewVx:=  1;
			   Snake.Vx:= NewVx;
			   end;
		 UpKey:    begin NewVx:= 0;
			   if Snake.Vy = 0 then NewVy:= -1;
			   Snake.Vy:= NewVy;
			   end;
		 DownKey:  begin NewVx:= 0;
			   if Snake.Vy = 0 then NewVy:=  1;
			   Snake.Vy:= NewVy;
			   end;
		 end; { case }
	       if NewVy = 0
		 then Snake.Ch:= DirCh[Snake.Vx, Snake.Vy]
		 else Snake.Ch:= DirCh[-Snake.Vx, -Snake.Vy];
	       Snake.Vx:= NewVx; Snake.Vy:= NewVy;
	       Snake.HeadCh:= headsch[Snake.Vx, Snake.Vy];
	       end;
	   end; { case }
	 end;
  end; { TestKeyBoard }

  procedure RemoveSH;
    var x, y: integer;
  begin 					{ ६墠    }
  for x:= 0 to Xsize -1 do
    for y:= 0 to Ysize-1 do
      if Board[x, y] and $f0 <> 0
	then begin Board[x, y]:= 0;
	     GotoXY(x+1, y+1); write(EmptyCh);
	     end; { if & for & for }

  GotoXY(Snake.HeadX+1, Snake.HeadY+1);
  if Board[Snake.HeadX, Snake.HeadY] <> 0
    then begin TextColor(Board[Snake.HeadX, Snake.HeadY]);
	 write(FullCh);
	 end
    else write(EmptyCh);

  Board[EntryX, EntryY]:= SaveBrdr;
  TextColor(SaveBrdr); GotoXY(EntryX+1, EntryY+1); write(FullCh);
  TextColor(SnakeColor);
  end; { RemoveSH }

  procedure PlayLevel;
  begin { PlayLevel }
  Snake.Size:= 0; Nhearts:= HeartsPerLevel; Gate.X:= -1; Gate.Y:= -1;
  NoErrors:= true; Time:= 0;
  DrawBoard;

  repeat MakeSnake; GotoXY(1, 25); TextColor(NormalText); ClrEol;
    write('ਣ⢥      ':34, LevelNo);
    while KeyPressed do if readkey = #0 then ;
    if (readkey = ESCkey) (*){*) or (readkey = #0) and (ReadKey = #0){*}
      then begin Nsnakes:= 0; score:= 0; (*) return {*) exit {*}; end;
    GotoXY(1, 25); clreol;
    (*)write(#27#3':.., :.., :..., 窨:........');
    {*)write(	#3':.., :.., :..., 窨:........');
       if not_40
	 then begin
	      write(',  : ');
	      if PlayerName <> ''
		then write(PlayerName, '': 13 - length(PlayerName))
		else write('   ');
	      write(',  : ', HS[1].score);
	      end;
    {*}

    WriteStatus; HrtOnScr:= 0; if Nhearts <> 0 then PutHeart(false);
    repeat MoveSnake;
      TestKeyboard;
    until Crash;
    Crash:= not ((Gate.X = Snake.HeadX) and (Gate.Y = Snake.HeadY));
    RemoveSH;
    if Crash
      then begin {   㤠 }
	   dec(Nsnakes);
	   NoErrors:= false;
	   end;
    WriteStatus;
  until not Crash or (Nsnakes = 0);
  if Crash
    then {    }
    else begin inc(Score, (4 + 6*ord(NoErrors)) * LevelNo);	 { give BONUS }
	 inc(Nsnakes, ord(NoErrors));
	 end;
  end; { PlayLevel }

  function NoMore: boolean;
    var ch: char;
        boza: string;
  begin
  Title; ShowTop; DoubleLine;
  if Position <> 0
    then begin (*){*)crt.{*}GotoXY(3, 6 + Position); write('>>'); end;

  GotoXY(1, 24);
  write(' ࠥ  ? a'#8#8);
  while keypressed do if readkey = #0 then; { clear keyboard }

  (*){*)Cursor(true); {*} ch:= readkey; (*){*)Cursor(false); {*}
  (*){*) if (ch = #0) and (ReadKey = #0) then ; {*}

  if ch in ['N', 'n', '', '', 'H', 'h', '', '', ESCkey]
    then begin write(#13); clreol;
	 write(' 类  ᪠   ࠥ? '#8#8);
	 (*){*)Cursor(true); {*} ch:= readkey; (*){*)Cursor(false); {*}
	 (*){*) if (ch = #0) and (ReadKey = #0) then ch:= ''; {*}
	 if not (ch in ['N', 'n', '', '', 'H', 'h', '', '', ESCkey])
	   then begin write(#13); clreol; GetName; end;
	 end;
  NoMore:= ch in ['N', 'n', '', '', 'H', 'h', '', '', ESCkey];
  write(#13); clreol;
  end; { NoMore }

  procedure InsertHighScore;
    var i: integer;
	NEWman: HighScore;
	f: file;
	w1, w2, w3, w4: cardinal;
	bap: ^ba;
  begin
  Position:= 0;
  if HS[16].Score < Score
    then begin NEWman.Score:= Score;
	 NEWman.name:= PlayerName;
	 NEWman.Level:= LevelNo;
	 GetDate(w1, w2, w3 (*){*), w4 {*});
	 NEWman.Date:= ((w1 - 1980) * 16 + w2) * 32 + w3;
	 GetTime(w1, w2, w3, w4);
	 NEWman.Time:= w1 * 60 + w2;
	 NEWman.rnd1:= random(65535); NEWman.rnd2:= random(65535);
	 NEWman.rnd3:= random(65535); NEWman.rnd4:= random(65535);
	 NEWman.rnd5:= random(65535); NEWman.rnd6:= random(65535);
	 NEWman.CheckSum:= 0;

	 w1:= 0; bap:= addr(NEWman);
	 for i:= 0 to SizeOf(NEWman)-1 do inc(w1, bap^[i]);

	 NEWman.CheckSum:= w1;

	 ReadHighScores;
	 i:= 16;
	 while (HS[i].Score < Score) and (0 < i) do dec(i);
	 inc(i);
	 if i < 17
	   then begin (*) MoveWords(HS[i], HS[i+1], WordSizeOf(HS[1])*(16-i));
		{*) Move(HS[i], HS[i+1], SizeOf(HS[i])*(16-i)); {*}
		HS[i]:= NEWman;
		(*) rewrite(f, HghScrName);
		{*) Fsplit(SYSTEM.ParamStr(0), p50, n50, e50);
		    (*$ifdef IN_IDE*) p50:= ''; (*$endif*)
		    assign(f, p50+HghScrName); rewrite(f, 1); {*}
		BlockWrite(f, HS, SizeOf(HS));
		close(f);
		if IOresult = 0 then Position:= i;
		end;
	 end;
  end; { InsertHighScore }

  procedure Initialize;
  begin
  (*){*) Cursor(false); {CheckBreak:= false;} {*}
  TextCo40; TextColor(NormalText);
  Title; HasntHigh:= true; ReadHighScores;
  ShowTop; DoubleLine; GetName;

  {$ifdef UniPas}
    DirCh[-1]:= (*)'ͼ '{*)'ͼ'{*};
    DirCh[ 0]:= (*)'  '{*)' '{*};
    DirCh[ 1]:= (*)' '{*)''{*};

    HeadsCh[-1,  0]:= #27#$11;
    HeadsCh[ 0, -1]:= #27#$1e;
    HeadsCh[ 0,  1]:= #27#$1f;
    HeadsCh[ 1,  0]:= #27#$10;

  {$else}
  if not_40
    then begin EmptyCh:= '  '; FullCh:= '';
	 ClockCh:= '';
	 HeartCh:= #3;
	 Snake.HeadCh:= '';
	 DirCh[-1, -1]:= ' '; DirCh[-1, 0]:= ''; DirCh[-1, 1]:= ' ';
	 DirCh[ 0, -1]:= ' ';                      DirCh[ 0, 1]:= ' ';
	 DirCh[ 1, -1]:= ''; DirCh[ 1, 0]:= ''; DirCh[ 1, 1]:= '';
	 HeadsCh[-1, 0]:= #$11'';
	 HeadsCh[ 0, -1]:= #$1e;
	 HeadsCh[ 0, 1]:= #$1f;
	 HeadsCh[ 1, 0]:= ''#$10
	 end
    else begin
	 DirCh[-1, -1]:= ''; DirCh[-1, 0]:= ''; DirCh[-1, 1]:= '';
	 DirCh[ 0, -1]:= '';                     DirCh[ 0, 1]:= '';
	 DirCh[ 1, -1]:= ''; DirCh[ 1, 0]:= ''; DirCh[ 1, 1]:= '';

	 HeadsCh[-1, 0]:= #$11;
	 HeadsCh[ 0, -1]:= #$1e;
	 HeadsCh[ 0, 1]:= #$1f;
	 HeadsCh[ 1, 0]:= #$10
	 end;
  {$endif}

  randomize;
  end; { Initialize }

begin { Sanke Byte }
Initialize;
repeat LevelNo:= 0; Nsnakes:= 3; Score:= 0;
  repeat ReadLevel(LevelNo);
    PlayLevel;
  until Nsnakes = 0;
  InsertHighScore;
until NoMore;
(*) TextColor(NormalText);
{*) ReturnMode; NormVideo; Cursor(true); {*}
end  { Snake Byte }.